SystemOrganization addCategory: #'Pier-OmniBrowser-Core'!
SystemOrganization addCategory: #'Pier-OmniBrowser-Nodes'!
SystemOrganization addCategory: #'Pier-OmniBrowser-Actors'!

!PREditCommand methodsFor: '*pier-omnibrowser-keystroke' stamp: 'lr 3/9/2006 11:30'!
keystroke
	^ $e! !

!PRCopyCommand methodsFor: '*pier-omnibrowser-keystroke' stamp: 'lr 3/9/2006 11:30'!
keystroke
	^ $c! !

!PRCommand methodsFor: '*pier-omnibrowser-keystroke' stamp: 'lr 3/9/2006 11:30'!
keystroke
	^ nil! !

MAElementMorph subclass: #PRStructureMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRStructureMorph methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
buildMorphEditor
	^ (SimpleHierarchicalListMorph
		on: self
		list: #root
		selected: #selected
		changeSelected: #selected:
		menu: nil
		keystroke: nil)
			hResizing: #spaceFill;
			borderColor: #inset;
			borderWidth: 2;
			expandAll;
			yourself! !

!PRStructureMorph methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:30'!
root
	^ Array with: (PRStructureItemWrapper with: self model context root)! !

!PRStructureMorph methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
selected
	^ PRStructureItemWrapper with: self value! !

!PRStructureMorph methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
selected: aWrapper
	self value: (aWrapper ifNotNil: [ aWrapper item ]).
	self changed: #selected! !

!PRAddCommand methodsFor: '*pier-omnibrowser-keystroke' stamp: 'lr 3/9/2006 11:30'!
keystroke
	^ $a! !

!PRMoveCommand methodsFor: '*pier-omnibrowser-keystroke' stamp: 'lr 3/9/2006 11:30'!
keystroke
	^ $m! !

!PRRemoveCommand methodsFor: '*pier-omnibrowser-keystroke' stamp: 'lr 3/9/2006 11:30'!
keystroke
	^ $x! !

!OBMetagraph methodsFor: '*pier-omnibrowser' stamp: 'lr 3/9/2006 11:30'!
pier
	| root kernel structure description |
	root := OBMetaNode named: 'Root'.
	kernel := OBMetaNode named: 'Kernel'.
	structure := OBMetaNode named: 'Structure'.
	description := OBMetaNode named: 'Description'.
	root
		childAt: #children
			labeled: 'children'
			put: kernel.
	kernel
		childAt: #children
			labeled: 'instances'
			put: structure;
		addActor: PRInspectActor new.
	structure
		childAt: #children
			labeled: 'children'
			put: structure;
		childAt: #description
			labeled: 'description'
			put: description;
		addActor: PRContextActor new;
		addActor: PRInspectActor new;
		filterClass: OBModalFilter.
	description
		childAt: #children
			labeled: 'children'
			put: description;
		childAt: #description
			labeled: 'description'
			put: description;
		addActor: PRInspectActor new;
		filterClass: OBModalFilter.
	^ root! !

OBBrowser subclass: #PRPierBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRPierBrowser class methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
defaultMetagraph
	^ #pier! !

!PRPierBrowser class methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
defaultRootNode
	^ PRRootNode on: PRKernel instances! !

!PRPierBrowser class methodsFor: 'initializing' stamp: 'lr 3/9/2006 11:30'!
initialize
	self registerInWorldMenu! !

!PRPierBrowser class methodsFor: 'initializing' stamp: 'lr 3/9/2006 11:30'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( PRPierBrowser open 'Pier Browser' 'A browser on your pier environments and its meta-descriptions.' ) forFlapNamed: 'Tools';
			replaceToolsFlap ]! !

!PRPierBrowser class methodsFor: 'initializing' stamp: 'lr 3/9/2006 11:30'!
registerInWorldMenu
	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: (Array
			with: 'Pier Browser'
			with: (Array
				with: self
				with: #open)) ]! !

!PRPierBrowser class methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
title
	^ 'Pier Browser'! !

!PRPierBrowser methodsFor: 'morphic' stamp: 'lr 3/9/2006 11:30'!
defaultBackgroundColor
	^ Color r: 0.151 g: 0.327 b: 0.720! !

!PRPierBrowser methodsFor: 'morphic' stamp: 'lr 3/9/2006 11:30'!
defaultLabel
	^ super defaultLabel , ': ' , self root name! !

OBNode subclass: #PRWikiNode
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

PRWikiNode subclass: #PRDescriptionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRDescriptionNode methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:30'!
children
	self model hasChildren
		ifFalse: [ ^ super children ].
	^ self model children
		collect: [ :each | self class on: each ]! !

!PRDescriptionNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
name
	^ self model label! !

PRWikiNode subclass: #PRKernelNode
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
children
	^ Array with: (PRStructureNode on: self model root holder: self)! !

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
context
	^ context! !

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
context: aContext
	context := aContext! !

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
model: aModel
	super model: aModel.
	self context: (PRContext kernel: aModel)! !

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
name
	^ self model name! !

PRWikiNode subclass: #PRRootNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRRootNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
children
	^ self model collect: [ :each | PRKernelNode on: each ]! !

!PRRootNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
name
	^ 'Root'! !

PRWikiNode subclass: #PRStructureNode
	instanceVariableNames: 'holder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRStructureNode class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
on: aModel holder: aHolder
	^ (self on: aModel)
		holder: aHolder;
		yourself! !

!PRStructureNode methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:30'!
children
	^ self model enumerator contents
		collect: [ :each | self class on: each holder: self holder ]! !

!PRStructureNode methodsFor: 'actions' stamp: 'lr 3/9/2006 11:30'!
clickLink: aLink
	aLink isInternal
		ifTrue: [ self context: (self context structure: aLink target) ]
		ifFalse: [
			WebBrowser default
				ifNotNilDo: [ :browser | aLink url asUrl activate ] ]! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
context
	^ self holder context structure: self model! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
context: aContext
	self holder context: aContext! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
holder
	^ holder! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
holder: aHolder
	holder := aHolder! !

!PRStructureNode methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:30'!
name
	^ self model title! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
text
	self model hasDocument
		ifFalse: [ ^ super text ].
	^ PRTextDocumentWriter new
		action: (MessageSend
			receiver: self
			selector: #clickLink:);
		write: self model document! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 4/25/2006 23:09'!
text: aString
	| editcontext |
	editcontext := self context command: model editCommandClass new.
	(editcontext isValid and: [ self context structure class respondsTo: #descriptionContents ])
		ifFalse: [ ^ super text: aString ].
	editcontext command
		write: aString using: self context structure class descriptionContents;
		execute.
	^ true! !

!PRWikiNode class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
on: aModel
	^ self new
		model: aModel;
		yourself! !

!PRWikiNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
children
	^ Array new! !

!PRWikiNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
description
	^ Array with: (PRDescriptionNode on: self model description)! !

!PRWikiNode methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
hash
	^ self model hash! !

!PRWikiNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
model
	^ model! !

!PRWikiNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
model: aModel
	model := aModel! !

!PRWikiNode methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
text
	^ self model printString! !

!PRWikiNode methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
= anObject
	^ self species = anObject species
		and: [ self model = anObject model ]! !

PRDocumentWriter subclass: #PRTextDocumentWriter
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRTextDocumentWriter methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
action
	^ action ifNil: [ action := self defaultAction ]! !

!PRTextDocumentWriter methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
action: aBlock
	action := aBlock! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
anchorAttributesFor: anObject
	^ Array with: (TextColor color: Color darkGray)! !

!PRTextDocumentWriter methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
defaultAction
	^ [ :value | value explore ]! !

!PRTextDocumentWriter methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
defaultStream
	^ TextStream on: Text new! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
headerAttributesFor: anObject
	^ Array with: TextEmphasis bold! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
linkAttributesFor: anObject
	^ Array
		with: (PluggableTextAttribute
			evalBlock: [ self action value: anObject ])
		with: (anObject isBroken
			ifTrue: [ TextColor color: (Color r: 0.5 g: 0.0 b: 0.0) ]
			ifFalse: [ TextColor color: (Color r: 0.0 g: 0.0 b: 0.5) ])
		with: TextEmphasis underlined! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
listAttributesFor: anObject
	^ Array with: (TextIndent tabs: 1)! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
preformattedAttributeFor: anObject
	^ Array with: TextEmphasis italic! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:30'!
smileyAttributesFor: anObject
	^ Array
		with: (TextColor color: Color orange)
		with: TextEmphasis bold! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitAnchor: anObject
	self
		withAttributes: (self anchorAttributesFor: anObject)
		do: [ super visitAnchor: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitHeader: anObject
	self
		withAttributes: (self headerAttributesFor: anObject)
		do: [ super visitHeader: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitLink: anObject
	self
		withAttributes: (self linkAttributesFor: anObject)
		do: [ super visitLink: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitOrderedList: anObject
	self
		withAttributes: (self listAttributesFor: anObject)
		do: [ super visitOrderedList: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitPreformatted: anObject
	self
		withAttributes: (self preformattedAttributeFor: anObject)
		do: [ super visitPreformatted: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitSmiley: anObject
	self
		withAttributes: (self smileyAttributesFor: anObject)
		do: [ super visitSmiley: anObject ]! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitUnorderedList: anObject
	self
		withAttributes: (self listAttributesFor: anObject)
		do: [ super visitUnorderedList: anObject ]! !

!PRTextDocumentWriter methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:30'!
withAttributes: aCollection do: aBlock
	^ self stream withAttributes: aCollection do: aBlock! !

ListItemWrapper subclass: #PRStructureItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRStructureItemWrapper methodsFor: 'converting' stamp: 'lr 3/9/2006 11:30'!
asString
	^ self item title! !

!PRStructureItemWrapper methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
contents
	^ self item children collect: [ :each | self class with: each ]! !

!PRStructureItemWrapper methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
hasContents
	^ self item hasChildren! !

!PRStructureItemWrapper methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
hash
	^ self item hash! !

!PRStructureItemWrapper methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
item
	^ item! !

!PRStructureItemWrapper methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
= anObject
	^ self species = anObject species
		and: [ self item = anObject item ]! !

OBActor subclass: #PRContextActor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Actors'!

!PRContextActor methodsFor: 'public' stamp: 'lr 3/9/2006 11:30'!
actionForNode: aNode in: aContext
	^ OBAction
		label: (String streamContents: [ :stream |
			stream nextPutAll: aContext command class shortLabel asLowercase.
			aContext command isQuick
				ifFalse: [ stream nextPutAll: '...' ] ])
		receiver: self
		selector: #runForNode:in:
		arguments: (Array with: aNode with: aContext)
		keystroke: aContext command keystroke! !

!PRContextActor methodsFor: 'public' stamp: 'lr 3/9/2006 11:30'!
actionsForNode: aNode
	^ (aNode context commands
		reject: [ :each | aNode model viewCommandClass = each ])
		collect: [ :each |
			self
				actionForNode: aNode
				in: (aNode context command: each new) ]! !

!PRContextActor methodsFor: 'actions' stamp: 'lr 3/9/2006 11:30'!
displayForNode: aNode in: aContext
	| result |
	aContext command isQuick
		ifTrue: [ ^ self executeForNode: aNode in: aContext ].
	result := aContext command asMorph
		addButtons;
		addWindow;
		callInWorld.
	result isNil
		ifFalse: [ self executeForNode: aNode in: aContext ]! !

!PRContextActor methodsFor: 'actions' stamp: 'lr 3/9/2006 11:30'!
executeForNode: aNode in: aContext
	aNode holder context: (aContext command execute; answer).
	aContext command answer command isView
		ifFalse: [ self displayForNode: aNode in: aContext command answer ]! !

!PRContextActor methodsFor: 'actions' stamp: 'lr 3/9/2006 11:30'!
runForNode: aNode in: aContext
	PRCurrentContext
		use: aNode holder
		during: [ self displayForNode: aNode in: aContext ].
	(PRStructureNode on: aNode context structure holder: aNode holder)
		signalSelection! !

OBActor subclass: #PRInspectActor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Actors'!

!PRInspectActor methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
actionsForNode: aClassNode
	^ Array
		with: (OBAction
			label: 'inspect'
			buttonLabel: String new
			receiver: aClassNode model
			selector: #inspect
			arguments: Array new
			keystroke: $i
			icon: MenuIcons inspectIcon)
		with: (OBAction
			label: 'explore'
			buttonLabel: String new
			receiver: aClassNode model
			selector: #explore
			arguments: Array new
			keystroke: $I
			icon: MenuIcons inspectIcon)! !
PRPierBrowser initialize!
